# $Header: /p/condor/repository/CONDOR_SRC/src_java/config.make,v 1.7 2002/04/02 14:29:44 solomon Exp $

# Configuration information for the ClassAd package, meant to be included
# by the GNUmake "include" directive

# Do no edit this file unless you intend your changes to be used by all users.
# Instead, create a file local.make in this directory and override settings
# there.

# Note:  This all should probably be replaced by imake or some such thing.

# WARNING:  This Makefile assumes the features of GNU make and JDK1.2 (or later)

# We assume that the including Makefile is in a subdir set up to build a
# particular package, and that the Makefile defines the following macros before
# including this file:
#    PACKAGE   the name of the package
#    TOP       a relative path from the subdir to the directory containing this
#              Makefile.
#    JLIBS     (optional) a colon-separated list of additional .jar files
#              needed to compile or run classes in the directory
# The including Makefile should also have at least one rule before including
# this Makefile, so that the default for "make" without any arguments is set.
#
# For example, the package condor.cedar is built in subdirectory
# ./condor/cedar (Java conventions require the name of the directory to end
# with "condor/cedar"), and ./condor/cedar contains
#
#     PACKAGE = condor.cedar
#     TOP = ../..
#     default: cedar.jar
#     include $(TOP)/config.make

# Figure out the platform type (OS = WINDOWS or OS = UNIX).
# Note on obscure gnumake feature:  $(findstring WIN xxx) evaluates to "WIN"
# if xxx (in this case the result of uname -s) contains the string
# "WIN".  The cygwin version of uname on Windows NT 4.0 returns
# "CYGWIN_NT-4.0".  Similar strings, such as CYGWIN_98-4.10, are returned on
# other Windows platforms.  Thus on a Windows platform, findstr returns a
# non-null string, so the test "ifneq ($(findstring...),)" succeeds and OS
# is defined to be WINDOWS. Bleah!
# 
# Changed to differentiate between Linux and Unix, because the lab default 
# java in linux is 1.2.2 but in Solaris it is not.  The logviewer needs 1.2.2
# so JAVA_HOME is different for Linux and Solaris.  johnbent

SYSNAME = $(shell uname -s)
ifneq ($(findstring WIN,$(SYSNAME)),)
OS = WINDOWS
else 
ifneq ($(findstring Lin,$(SYSNAME)),)
OS = LINUX
else
# assume anything else is Unix
OS = UNIX
endif
endif

######### Tool definitions.
# Any of the following definitions can be overridden by creating a file
# named local.make in the same directory as this file.

ifeq ($(OS),WINDOWS)

# Tool definitions: Windows

JAVA_HOME = /jdk1.1.7B
PERL = /perl/bin/perl

else

# Tool definitions: Unix
PERL = /s/std/bin/perl
JAVA_HOME = /s/jdk1.4.0

endif

# Tool defintions: Common

JAVA = $(JAVA_HOME)/bin/java
JAVADOC = $(JAVA_HOME)/bin/javadoc
JAR = $(JAVA_HOME)/bin/jar
JAVALIB = $(JAVA_HOME)/jre/lib/rt.jar
JAVAC = /s/std/bin/jikes

# To use javac instead of jikes for compiling, add the line
#    JAVAC = $(JAVA_HOME)/bin/javac
# to local.make.  Do not make the change to this file, because you may forget
# and check it in to CVS.

# Default option flags
JAVA_FLAGS = $(CPFLAG)

# To get a stack trace with line numbers, at the expense of slower execution
# speed, add the line
#        JAVA_FLAGS += -Djava.compiler=NONE
# to your local.make.  Don't forget the +.
JAVAC_FLAGS = -g $(CPFLAG)
JAVADOC_FLAGS = -author -version

##########################
-include $(TOP)/local.make
##########################

# NB: As of Java 1.2, $(JAVALIB) need not be explicitly mentioned for javac,
# although it does no harm to add it here.  It is included here because jikes
# requires it, if you use $(JAVAC) = jikes.
CPFLAG := -classpath $(JAVALIB):$(TOP)

ifneq ($(JLIBS),)
CPFLAG := $(CPFLAG):$(JLIBS)
endif
CPFLAG := $(CPFLAG):.

ifeq ($(PLATFORM),WIN32)
CPFLAG := $(subst :,;,$(CPFLAG))
endif

%.class: %.java
	$(JAVAC) $(JAVAC_FLAGS) \
		$<

jar: all
	$(MAKE) -C $(TOP) $(PACKAGE).jar

clean::
	$(RM) *.class *.jar

.PHONY: jar

# vim:syntax=make
